--
-- Created by IntelliJ IDEA.
-- User: Jens
-- Date: 25.03.14
-- Time: 18:38
-- To change this template use File | Settings | File Templates.
--
local L = LibStub("AceLocale-3.0"):GetLocale("PimpMyProfession")


function PimpMyProfession:GetNeedList(beruf, myrank)
    local needList

    if beruf == 171 then
       needList = PimpMyProfession.PmpDBAlchNeeds.shoplist
    end

    for k, v in pairs(needList) do

        if(v.plevel[2] <= myrank and v.plevel[3] > myrank) then
           -- laden der Itemdaten aus der Liste
            print("Lade Einkaufsliste für deinen Skillbereich...")
            for index, i in pairs(v.needs) do
               local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
               itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(i[1])
               local n = {
                    iName = itemName,
                    count = i[2],
                    texture = itemTexture,
                    iType = itemType,
                    itemid= i[1],
                    iRarity=itemRarity,
               }
               table.insert(PimpMyProfession.actualGuide.needlist, n)
            end
        end
    end
end

function PimpMyProfession:CreateNeedListFrame(beruf, myrank)
    --for index, key in pairs(PimpMyProfession.professions) do
       --print(index,key.skillline)
    --end
    PimpMyProfession:GetNeedList(beruf, myrank)
    local f = CreateFrame("Frame",nil, UIParent)
    f:SetClampedToScreen(true)
    f:SetMovable(true)
    f:EnableMouse(true)
    f:SetScript("OnMouseDown", function(self,button)
        if button == "LeftButton" and not self.isMoving then
            self:StartMoving();
            self.isMoving = true;
        end
    end)
    f:SetScript("OnMouseUp", function(self, button)
        if button == "LeftButton" and self.isMoving then
            self:StopMovingOrSizing()
            self.isMoving = false
        end
    end)
    f:SetScript("OnHide", function(self)
        if(self.isMoving) then
            self:StopMovingOrSizing()
            self.isMoving=false
        end
    end)
    f:SetWidth(460)
    f:SetHeight(300)
    f:SetBackdrop{
        bgFile = [[Interface\ToolTips\ChatBubble-Background.blp]],
        edgeFile = [[Interface\ToolTips\UI-Tooltip-Border]],
        edgeSize = 16,
        tile = true, tileSize = 16,
        insets = {left = 4, right = 4, top = 4, bottom = 4}
    }
    f:SetPoint("CENTER",0,0)
    f.title = f:CreateFontString("NeedList_Title", "OVERLAY", "GameFontNormal")
    f.title:SetPoint("TOP",0,-8)
    f.title:SetText(L["NeedList Frame Title"])
    f.close = CreateFrame("Button", "nList_close", f, "UIPanelCloseButton")
    f.close:SetPoint("TOPRIGHT", 0,-2)

    --laden der Needliste
    f.items = {}
    local idx=1
    for index, key in pairs(PimpMyProfession.actualGuide.needlist) do
        local item = CreateFrame("Button", "Nlist_item" ..idx, f, "SecureActionButtonTemplate")
        item:SetSize(48,48)
        item:SetScript("OnEnter", function(self,...)
            print(self.data.iName, self.data.iType, self.data.iRarity)

        end)
      local border = item:CreateTexture(nil, 'OVERLAY')
        border:SetWidth(67)
        border:SetHeight(67)
        border:SetPoint('CENTER', item)
        --border:SetTexture([[Interface\Buttons\UI-ActionButton-Border]])
        r,g,b,h = GetItemQualityColor(key.iRarity)
        border:SetVertexColor(r,g,b)
        border:SetBlendMode('ADD')

        --border:Hide()

        --item.border = border




        item.icon = item:CreateTexture("", "BACKGROUND")
        item.icon:SetAllPoints(item)
        item.icon:SetSize(64,64)
        item.icon:SetTexture(key.texture)
        item.icon:Show()
        item.data = key
        local needCount = GetItemCount(key.itemid)
        item.count = item:CreateFontString("$parentCount", "BORDER", "NumberFontNormal")
        item.count:SetPoint("BOTTOMRIGHT", -5,2)
        item.count:SetJustifyH("RIGHT")

        -- ist die benötigte Anzahl vorhanden, dann Schriftfarbe auf grün stellen
        if(needCount >= key.count) then
             item.count:SetTextColor(0, 1.0,0,1)
        else
             item.count:SetTextColor(1,1,1,1)
        end
        item.count:SetText(needCount.."/"..key.count)
        --item.count:Hide()

--[[
        item.glow = item:CreateTexture("", "OVERLAY")
        item.glow:SetWidth(70)
        item.glow:SetHeight(70)
        item.glow:SetTexture("Interface\\Buttons\\UI-ActionButton-Border")
        item.glow:SetBlendMode("ADD")
        item.glow:SetAlpha(0.6)
        item.glow:SetPoint("CENTER")
]]

        f.items[idx] = item

        if idx == 1 then
            item:SetPoint("TOPLEFT", 10, 0)
        elseif idx == 8 or idx == 15 or idx == 22 then
            item:SetPoint("TOPLEFT", f.items[idx - 7], "BOTTOMLEFT", 0, -7)
        else
            item:SetPoint("TOPLEFT", f.items[idx - 1], "TOPRIGHT", 12, 0)
        end

        idx = idx +1

    end

    return f
end

function PimpMyProfession:GetNeedList2(profession)

    if PimpMyProfession.MainFrame:IsVisible() then PimpMyProfession.MainFrame:Hide() end
	PimpMyProfession:UpdateGuide(profession)

    local f = CreateFrame("Frame", "needlist", UIParent)
    f:ClearAllPoints()
    f:SetClampedToScreen(true)
    f:EnableMouse(true)
    f:SetMovable(true)
    f:SetPoint("CENTER", UIParent)
    f:SetWidth(640)
    f:SetHeight(400)
	f:SetBackdrop{
        bgFile = [[Interface\ToolTips\UI-Tooltip-Background]],
        edgeFile = [[Interface\AddOns\PimpMyProfession\Textures\FrameTitle-border]],
        edgeSize = 32,
        tile = true, tileSize = 16,
        insets = {left = 1, right = 1, top = 20, bottom = 1}
    }
	f:SetScript("OnMouseDown", function(self,button) 
		if button == "LeftButton" then
		   self:StartMoving()
			self.isMoving = true
		end
	end)
	f:SetScript("OnMouseUp", function(self) 
		if self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
		end

	end)
	f:SetBackdropBorderColor(1.0,0.0,0.0)
	f:SetBackdropColor(25/255,25/255,24/255)

	f.Title = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	f.Title:SetPoint("TOP",f,"TOP", 0,-12)
	f.Title:SetJustifyH("CENTER")
	f.Title:SetText(profession.name.."["..profession.plevel.."]")
	
	f.Rezepte=PimpMyProfession:CreateInsetFrame("Aktuelles Rezept", f)

	f.CloseButton = CreateFrame("Button","nlisFrame_CloseButton", f)
	f.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	f.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	f.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	f.CloseButton:SetWidth(20)
	f.CloseButton:SetHeight(20)
	f.CloseButton:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-12)
	f.CloseButton:SetScript("OnClick", function(self) self:GetParent():Hide() end)
	LoadAddOn("Blizzard_TradeSkillUI")
local tradeskill_professions = {
    ['01Tailoring'] = {spellid=3908, recipes=true},
    ['02Enchanting'] = {spellid=7411, recipes=true},
    ['04Smelting'] = {spellid=2656, recipes=true},
    ['05Blacksmithing'] = {spellid=3100, recipes=true},
    ['06Alchemy'] = {spellid=2259, recipes=true},
    ['07Leatherworking'] = {spellid=2108, recipes=true},
    ['08Engineering'] = {spellid=4036, recipes=true},
    ['09Jewelcrafting'] = {spellid=25229, recipes=true},
    ['10Inscription'] = {spellid=45357, recipes=true},
    ['11Runeforging'] = {spellid=53428, recipes=true},
    ['14Cooking'] = {spellid=2550, recipes=true},
    ['16First Aid'] = {spellid=3273, recipes=true},
};
    for name, data in pairs(tradeskill_professions) do     
        local spellid = data.spellid;
        local spellname, rank, texture, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellid);
		if(spellname == profession.name) then
			print(spellname)
			CastSpellByName(spellname,"player")
		end
	end
	--TradeSkillFrame:Show()
	--Test
	
	for i=1, GetNumTradeSkills() do
		print(select(1,GetTradeSkillInfo(i)))
	end

end

function PimpMyProfession:CreateInsetFrame(title, frame)
	local f = CreateFrame("Frame", nil, frame)
	f:SetHeight(100)
	f:SetWidth(350)
	f:SetBackdrop{
		bgFile = [[Interface\ToolTips\ChatBubble-Background]], tile=true, tileSize=16,
		edgeFile=[[Interface\ToolTips\UI-Tooltip-Border]],
		edgeSize=16,
		insets={left = 4, right = 4, top = 4, bottom = 4}
	}
	f:SetPoint("TOPLEFT",5,-10)
	return f

end


function PimpMyProfession:UpdateGuide(profession)
    if PimpMyProfession.actualGuide == nil then return nil end
    local Guide = PimpMyProfession:GetModule("Guide")
    local von, bis, plevel
    for index, key in pairs(Guide.SkillAreas) do
        if profession.maxrank == key.t then
            von = key.f
            bis = key.t
            plevel = key.name
			profession.plevel=key.name
        end
    end
    --ermitteln aller rezepte meines Professionlevels
    local levelRezepte = {}
    for i=1, #PimpMyProfession.actualGuide do
        if PimpMyProfession.actualGuide[i][1] >= profession.rank and PimpMyProfession.actualGuide[i][2] <= bis then
            table.insert(levelRezepte,PimpMyProfession.actualGuide[i])
        end
    end
    local farmlist = {}
    for i= 1, #levelRezepte do
        local dummy = {}
        if levelRezepte[i][1] >= profession.rank and levelRezepte[i][2] <= profession.maxrank then
            local rcount = levelRezepte[i][3]  --Anzahl der herzustellenden Items
            local dist = levelRezepte[i][2] - profession.rank
            -- soltte mein skill zwischen einem Rezept liegen, dann berechne die noch erforderliche Menge
            if levelRezepte[i][1] >= profession.rank and levelRezepte[i][2]<=profession.rank then
                --Da mann mehr herstellen kann als es skill punkte gibt, muss entsprechend berechnet werden
                if(levelRezepte[i][2] - levelRezepte[i][1]) < levelRezepte[i][3] then
                    dist = dist + (levelRezepte[i][3] - (levelRezepte[i][2] - levelRezepte[i][1]))
                end
                for a=1, #levelRezepte[i][6] do
                    levelRezepte[i][6][a][1] = levelRezepte[i][6][a][3] * dist
                end
            end
            for a = 1, #levelRezepte[i][6] do
                table.insert(dummy,levelRezepte[i][6][a])
            end
        end

        --zuzammenstellen der farmliste
        for x= 1, #dummy do
            local isda = false
            for y=1, #farmlist do
                if farmlist[y][2] == dummy[x][2] then
                    farmlist[y][1] = farmlist[y][1] + dummy[x][1]
                    isda = true
                end
            end
            if not isda then table.insert(farmlist,dummy[x]) end
        end
    end
    PimpMyProfession.AktualFarmlist = farmlist
end